module sc_cu (opcode,func7,func3,z,aluc,alui,pcsrc,m2reg,bimm,call,wreg,wmem); // sc control unit
    input  [6:0] opcode;
    input  [6:0] func7;
    input  [2:0] func3;
    input        z;
    
    output [3:0] aluc;
    output [1:0] alui;
    output [1:0] pcsrc;
    output       m2reg;
    output       bimm;
    output       call;
    output       wreg;
    output       wmem;

    // instruction decode
    wire i_lui   = (opcode == 7'b0110111);
    wire i_jal   = ; //
    wire i_jalr  = (opcode == 7'b1100111) & (func3 == 3'b000);
    wire i_beq   = ; //
    wire i_bne   = ; //
    wire i_lw    = ; //
    wire i_sw    = ; //
    wire i_addi  = ; //
    wire i_xori  = ; //
    wire i_ori   = ; //
    wire i_andi  = ; //
    wire i_slli  = (opcode == 7'b0010011) & (func3 == 3'b001) & (func7 == 7'b0000000);
    wire i_srli  = ; //
    wire i_srai  = ; //
    wire i_add   = ; //
    wire i_sub   = ; //
    wire i_slt   = ; //
    wire i_xor   = ; //
    wire i_or    = ; //
    wire i_and   = ; //

    // control signals
    assign aluc[0]  = ; //
    assign aluc[1]  = ; //
    assign aluc[2]  = ; //
    assign aluc[3]  = i_xori | i_xor | i_srai;
    assign m2reg    = i_lw;
    assign wmem     = i_sw;
    assign wreg     = i_lui  | i_jal | i_jalr | i_lw | i_addi | i_xori | i_ori | i_andi | i_slli | i_srli | i_srai | i_add | i_sub | i_slt | i_xor | i_or | i_and;
    assign pcsrc[0] = ; //
    assign pcsrc[1] = ; //
    assign call     = ; //
    assign alui[0]  = ; //
    assign alui[1]  = ; //
    assign bimm     = ; //
endmodule
